#include "KupacT.h"
#include <iostream>

using namespace std;

KupacT::KupacT()
{
    //ctor
    db=0;
    hiba=false;
}

KupacT::~KupacT()
{
    //dtor
}

bool KupacT::ures_e(){
    return (db==0);
}

bool KupacT::hibas_e(){
    bool tmp=hiba;
    hiba=false;
    return tmp;
}

void KupacT::kupacba(ElemT e){
    if (db==MaxN) {
        hiba=true;
    } else {
        db++;
        t[db]=e;
        felcsusztat(db);
    }
}

ElemT KupacT::elso(){
    if (ures_e()) {
        hiba=true;
        return UnDef;
    } else {
        return t[1];
    }
}

ElemT KupacT::kupacbol(){
    if (ures_e()) {
        hiba=true;
        return UnDef;
    } else {
        ElemT e=t[1];
        t[1]=t[db];
        db--;
        lecsusztat(1);
        return e;
    }
}

void KupacT::dump(){
    cerr << " Kupac dump:";
    for (int i=1;i<=db;i++) {
        cerr << " " << t[i];
    }
    cerr << endl;
    cerr << endl;
}

IndexT KupacT::kisebb(IndexT a, IndexT b){
    if ((b>db) || (t[a]<=t[b])) {
        return a;
    }else {
        return b;
    }
}

void KupacT::felcsusztat(IndexT i){
    ElemT e=t[i];
    while ((i>1) && (e<t[i/2])) {
        t[i]=t[i/2];
        i=i/2;
    }
    t[i]=e;
}

void KupacT::lecsusztat(IndexT i){
    IndexT j=kisebb(2*i,2*i+1);
    ElemT e=t[i];
    while ((i<=db/2) && (e>t[j])) {
        t[i]=t[j];
        i=j;
        j=kisebb(2*i,2*i+1);
    }
    t[i]=e;
}
